﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace sms
{
    class smsV2
    {
		// 请根据实际 accesskey 和 secretkey 进行开发，以下只作为演示 sdk 使用
                   static string accesskey = "";
	    static string secretkey="";
		
        static string url = "https://live2.moduyun.com/sms/v2/sendsinglesms";

       //短信签名ID (登录后台页面获取)
     	 static	string signId="";
	    
         static string templateId="";
        static void Main(string[] args)
        {
            //短信模板的变量值 ，将短信模板中的变量{1},{2}替换为参数中的值
     	    JArray array = new JArray();
     		//模板中存在多个可变参数，可以添加对应的值。
           array .Add("333355");
			// 手机号码
            String phoneNumber = "";
			
       
            String singleSenderResult = send(0, "86", phoneNumber,signId, templateId, array, "");


            Console.WriteLine(singleSenderResult);
            // Console.ReadLine();
        }


        private static String send(int type,string nationCode,string phoneNumber,string signId,string templateId,JArray array,string ext)
        {
            // 校验 type 类型
		if (0 != type && 1 != type) {
			throw new Exception("type " + type + " error");
		}
			
		if (null == ext) {
			ext = "";
		}
            long random = getRandom();
            long curTime = getCurTime();

            String wholeUrl = url+"?accesskey="+accesskey+"&random="+random;

            Console.WriteLine(wholeUrl);

            HttpWebRequest httpWReq = (HttpWebRequest)WebRequest.Create(wholeUrl);
            

        string sig = "secretkey=" + secretkey + "&random=" + random + "&time=" + curTime + "&mobile=" + phoneNumber;
        sig = SHA256Encrypt(sig);
       

            Encoding encoding = new UTF8Encoding();

           
           // String tel = "{"nationcode": + nationCode ,"mobile":"" + phoneNumber+""}";
           // string postData = "{"type": + type+ ,"msg": + msg+ ,"sig": + sig+ ,"tel": + tel+ ,"time": + curTime+ ,"extend": + extend+ ,"ext": + ext+""}";
           
           JsonTel tel = new JsonTel();
           JsonData postData = new JsonData();
           tel.nationcode = nationCode;
           tel.mobile = phoneNumber;

          
           postData.signId = signId;
           postData.type = type;
           postData.sig = sig ;
           postData.tel = tel;
           postData.time =curTime;
           postData.templateId = templateId;
           postData.ext = ext;
           postData.parameter = array;
           
           string json = JsonConvert.SerializeObject(postData);

           Console.WriteLine(json);
           
           
            byte[] data = encoding.GetBytes(json);

          

            httpWReq.ProtocolVersion = HttpVersion.Version11;
            httpWReq.Method = "POST";
            httpWReq.ContentType = "application/json";//charset=UTF-8";
            httpWReq.Headers.Add("X-Amzn-Type-Version",
                                               "com.amazon.device.messaging.ADMMessage@1.0");
            httpWReq.Headers.Add("X-Amzn-Accept-Type",
                                            "com.amazon.device.messaging.ADMSendResult@1.0");
           // httpWReq.Headers.Add(HttpRequestHeader.Authorization,
                //"Bearer " + accessToken);
            httpWReq.ContentLength = data.Length;


            Stream stream = httpWReq.GetRequestStream();
            stream.Write(data, 0, data.Length);
            stream.Close();

            HttpWebResponse response = (HttpWebResponse)httpWReq.GetResponse();
            string s = response.ToString();
            StreamReader reader = new StreamReader(response.GetResponseStream());
            String jsonresponse = "";
            String temp = null;
            while ((temp = reader.ReadLine()) != null)
            {
                jsonresponse += temp;
            }
            return jsonresponse;

        }

        public static long getRandom()
        {
            Random random = new Random();
            return (random.Next(999999)) % 900000 + 100000;
        }

        /// <summary>    
        /// 获取时间戳    
        /// </summary>  
        public static long getCurTime()
        {
            //TimeSpan ts = DateTime.UtcNow - new DateTime(1970, 1, 1, 0, 0, 0, 0);
          //  return Convert.ToInt64(ts.TotalSeconds).ToString();
          return   (long) (DateTime.UtcNow.Subtract(new DateTime(1970, 1, 1)).TotalMilliseconds) / 1000;
        }  

        /// <summary>
        /// SHA256加密，不可逆转
        /// </summary>
        /// <param name="str">string str:被加密的字符串</param>
        /// <returns>返回加密后的字符串</returns>
        public static string SHA256Encrypt(string str)
        {
            //System.Security.Cryptography.SHA256 s256 = new System.Security.Cryptography.SHA256Managed();
            //byte[] byte1;
            //byte1 = s256.ComputeHash(Encoding.UTF8.GetBytes(str));
            //s256.Clear();
            //return Convert.ToBase64String(byte1);

            byte[] bytes = Encoding.UTF8.GetBytes(str);
            HashAlgorithm algorithm = null;
            algorithm = new SHA256Managed();
            return BitConverter.ToString(algorithm.ComputeHash(bytes)).Replace("-", "").ToLower();
        }

        public class JsonData {
        public int type

        {
            get;
            set;
        }

        public string sig

        {
            get;
            set;
        }

        public string templateId

        {
            get;
            set;
        }

        public string signId

        {
            get;
            set;
        }

        public long time

        {
            get;
            set;
        }

        public JArray parameter

        {
            get;
            set;
        }

        public string ext

        {
            get;
            set;
        }




       

        public JsonTel tel

        {
            get;
            set;
        }


    }

    public class JsonTel {

        public string nationcode

        {
            get;
            set;
        }

        public string mobile

        {
            get;
            set;
        }
     }


    }
}
